'software / hardware used to generate a sequencer for trx hardware
'1 input
'3 outputs with 50 mS internal delay


$regfile = "attiny45.dat"
$crystal = 8000000

$hwstack = 32
$swstack = 32
$framesize = 32

$projecttime = 1

Const Timing_act = 50
Const Timing_deact = 30
'-------------------------------------------------------------------------------
'declare subs
Declare Sub Set_output()
Declare Sub Reset_output()

'-------------------------------------------------------------------------------
'config i/o

Status_led Alias Portb.4
Config Status_led = Output
Reset Status_led

Output0 Alias Portb.0
Config Output0 = Output
Reset Output0

Output1 Alias Portb.3
Config Output1 = Output
Reset Output1

Output2 Alias Portb.1
Config Output2 = Output
Reset Output2

Ptt_input Alias Pinb.2
Set Portb.2                                                 'enable pullup

Dim Ptt_status As Bit
Ptt_status = Ptt_input

Dim Timer0_cnt As Byte

'-------------------------------------------------------------------------------
'configure timer

Config Timer0 = Timer , Prescale = 64

On Ovf0 Isr_ovf0

Enable Timer0
Enable Interrupts
'-------------------------------------------------------------------------------
'main program

Call Reset_output()

Do                                                          'main loop

   Stop Timer0
   Set Status_led

   While Ptt_input = 1
      'loop here and do noting until input = 0
   Wend                                                     'wait to become 0

   Start Timer0
   Call Set_output()

   While Ptt_input = 0
      'loop here and do noting until input = 1
   Wend                                                     'wait to become 1

   Call Reset_output()

Loop

Sub Set_output()
   Set Output0                                              'make it active
   Waitms Timing_act
   Set Output1
   Waitms Timing_act
   Set Output2
   Waitms Timing_act
End Sub

Sub Reset_output()
   Reset Output2
   Waitms Timing_deact
   Reset Output1
   Waitms Timing_deact
   Reset Output0
   Waitms Timing_deact
End Sub


Isr_ovf0:

   Incr Timer0_cnt
   If Timer0_cnt > 33 Then
      Timer0_cnt = 0
      Toggle Status_led
   End If

Return

End